#!/usr/bin/env python

import string, httplib, urllib2, urllib
from xml.dom import minidom

class pytumblr(object):
	"""Tumblr API Object.
	pt = pytumblr(user, email, password, generator)
	
	pt.blogwrite(type='')

	pt.blogread(start, num, type, id)

	 where 	start = post number to start at
	 	num = number of posts to get (default 20)
		type = type to get
		id = id number to get

	pt.auth() - Authentification Test"""


	def __init__(self, user, email, password, generator='pytumblr'):
		self.user = user
		self.email = email
		self.password = password
		self.generator = generator 
		self.url = "www.tumblr.com"

	def __repr__(self):
		return "< %s initialized: (%s, %s) >" %(type(self).__name__, self.user, self.email)
	
	def blogwrite(self, type="", t="", b="", s="", c="", ctu="", q="", n="", u="", d="", conv="", private="", tags=""):
		email = self.email
		password = self.password
		generator = self.generator
		try:
			if ( int(private) > 1 or int(private) < 0):
				return 'Invalid Option: %s - private must be 1 or 0' %(private)
		except:
			private=0
		if ( type == 'regular' or type == ''):
			values = { 
					'title' : t, 
					'body' : b
					}
		if ( type == "photo"):
				values = { 
					'source' : s, 
					'caption' : c, 
					'click-through-url' : ctu
					}
		if ( type == "quote"):
			values = { 
					'quote' : q,
					'source' : s
					}
		if ( type == "link"):
			values = { 
					'name' : n,
					'url' : u,
					'description' : d
					}
		if ( type == "convo"):
			values = { 
					'title' : t,
					'conversation' : conv
					}

		values['generator'] = self.generator 
		values['priavte'] = private
		values['tags'] = tags
		values['email'] = self.email
		values['password'] = self.password
		values['type'] = type

		data = urllib.urlencode(values)
		headers = {"Content-type": "application/x-www-form-urlencoded"}
		conn = httplib.HTTPConnection(self.url)
		conn.follow_all_redirects = True
		conn.request("POST",'/api/write', data, headers)
		response = conn.getresponse()
		if ( int(response.status) == 201):
			return 'Success'
		elif( int(response.status) != 201):
			raise 'Error - Status %s (%s) returned' %(response.status, response.reason)

	def auth(self):
		values = {
			'action' : 'authenticate',
			'password': self.password,
			'email': self.email
			}
		data = urllib.urlencode(values)
		headers = {"Content-type": "application/x-www-form-urlencoded"}
		conn = httplib.HTTPConnection(self.url)
		conn.follow_all_redirects = True
		conn.request("POST", '/api/write', data, headers)
		response = conn.getresponse()
		if ( int(response.status) != 200 ):
			return '< There was a tiny problem: %s (%s) >' %(response.status, response.reason)
		if ( int(response.status) == 200 ):
			return '< Authenticated! >'
	

	def blogread(self, start='None', num='None', type='None', id='None'):
		opts = ''
		if ( start != 'None' ):
			opts = opts + '?start=' + start 
		if ( num != 'None' ):
			opts = opts + "?num=" + num
		if ( type != 'None' ):
			opts = opts + "?type=" + type
		if ( id != 'None' ):
			opts = opts + "?id=" + id
		return urllib.urlopen('http://%s.tumblr.com/api/read%s' %(self.user, opts)).read()
		
	def getblog(self):
		rxml = minidom.parseString(self.blogread())
		titles = rxml.getElementsByTagName('regular-title')
		postid = rxml.getElementsByTagName('post')
		i = 0
		n = 0
		posts = {}
		while ( i < len(postid)):
			if ( postid[i].attributes['type'].value == 'regular' ):
				t = titles [n]
				t = t.toxml()
				t = t.replace('<regular-title)', '')
				t = t.replace('</regular-title)', '')
				poid = postid[i].attributes["id"].value
				posts[ poid ] = t
				n = n + 1
			if ( postid[i].attributes['type'].value != 'regular' ):
				pass
			i = i + 1
		return posts
